//  -*- Mode: c++ -*-
// ============================================================================
// 
// Copyright (c) 1997 The CGAL Consortium
//
// This software and related documentation is part of an INTERNAL release
// of the Computational Geometry Algorithms Library (CGAL). It is not
// intended for general use.
//
// ----------------------------------------------------------------------------
//
// release       : $CGAL_Revision: CGAL-1.0 $
// release_date  : $CGAL_Date: 1998/09/12 $
//
// file          : include/CGAL/bops_Container_Polygon_2.h
// source        : include/CGAL/bops_Container_Polygon_2.h
// revision      : $Revision: 1.1.2 $
// revision_date : $Date: Wed Dec  9 13:28:46 MET 1998  $
// author(s)     :              Wolfgang Freiseisen <Wolfgang.Freiseisen@risc.uni-linz.ac.at>
//
// coordinator   : RISC Linz
//  (Wolfgang Freiseisen <wfreisei@risc.uni-linz.ac.at>)
//
// 
// ============================================================================

#ifndef CGAL_BOPS_CONTAINER_POLYGON_2_H
#define CGAL_BOPS_CONTAINER_POLYGON_2_H


/***********************************/ 
/* For Polygons with traits class: */
/***********************************/ 


template < class ForwardIterator, class Traits >
bool CGAL_do_intersect( ForwardIterator Afirst, ForwardIterator Alast,
		        ForwardIterator Bfirst, ForwardIterator Blast,
		        Traits &);


template < class ForwardIterator, class OutputIterator, class Traits >
OutputIterator
CGAL_intersection( ForwardIterator Afirst, ForwardIterator Alast,
     	           ForwardIterator Bfirst, ForwardIterator Blast,
                   Traits &, OutputIterator list_of_objects_it);


template < class ForwardIterator, class OutputIterator, class Traits >
OutputIterator
CGAL_union(        ForwardIterator Afirst, ForwardIterator Alast,
                   ForwardIterator Bfirst, ForwardIterator Blast,
		   Traits &, OutputIterator list_of_objects_it);


template < class ForwardIterator, class OutputIterator, class Traits >
OutputIterator
CGAL_difference(   ForwardIterator Afirst, ForwardIterator Alast,
		   ForwardIterator Bfirst, ForwardIterator Blast,
		   Traits &, OutputIterator list_of_objects_it);

 
 
#ifdef CGAL_CFG_NO_AUTOMATIC_TEMPLATE_INCLUSION
#include <CGAL/bops_Container_Polygon_2.C>
#endif

#endif // CGAL_BOPS_CONTAINER_POLYGON_2_H
