//  -*- Mode: c++ -*-
// ============================================================================
// 
// Copyright (c) 1997 The CGAL Consortium
//
// This software and related documentation is part of an INTERNAL release
// of the Computational Geometry Algorithms Library (CGAL). It is not
// intended for general use.
//
// ----------------------------------------------------------------------------
//
// release       : $CGAL_Revision: CGAL-1.0 $
// release_date  : $CGAL_Date: 1998/09/12 $
//
// file          : include/CGAL/bops_Polygon_2.h
// source        : include/CGAL/bops_Polygon_2.h
// revision      : $Revision: 1.1.2 $
// revision_date : $Date: Wed Dec  9 13:28:47 MET 1998  $
// author(s)     :             Wolfgang Freiseisen <Wolfgang.Freiseisen@risc.uni-linz.ac.at>
//
// coordinator   : RISC Linz
//  (Wolfgang Freiseisen <wfreisei@risc.uni-linz.ac.at>)
//
// 
// ============================================================================

#ifndef CGAL_BOPS_POLYGON_2_H
#define CGAL_BOPS_POLYGON_2_H


#include <CGAL/bops_traits_2.h>


template < class R, class Container >
bool CGAL_do_intersect(
     const CGAL_Polygon_2<CGAL_Polygon_traits_2<R>, Container>& A,
     const CGAL_Polygon_2<CGAL_Polygon_traits_2<R>, Container>& B
);


template < class R, class Container, class OutputIterator >
OutputIterator
CGAL_intersection( const CGAL_Polygon_2<CGAL_Polygon_traits_2<R>, Container>& A,
                   const CGAL_Polygon_2<CGAL_Polygon_traits_2<R>, Container>& B,
                   OutputIterator list_of_objects_it);

 
template < class R, class Container, class OutputIterator >
OutputIterator
CGAL_union(        const CGAL_Polygon_2<CGAL_Polygon_traits_2<R>, Container>& A,
                   const CGAL_Polygon_2<CGAL_Polygon_traits_2<R>, Container>& B,
                   OutputIterator list_of_objects_it);
 
 
template < class R, class Container, class OutputIterator >
OutputIterator
CGAL_difference(   const CGAL_Polygon_2<CGAL_Polygon_traits_2<R>, Container>& A,
                   const CGAL_Polygon_2<CGAL_Polygon_traits_2<R>, Container>& B,
                   OutputIterator list_of_objects_it);

 
#ifdef CGAL_CFG_NO_AUTOMATIC_TEMPLATE_INCLUSION
#include <CGAL/bops_Polygon_2.C>
#endif

#endif // CGAL_BOPS_POLYGON_2_H
