//  -*- Mode: c++ -*-
// ============================================================================
// 
// Copyright (c) 1997 The CGAL Consortium
//
// This software and related documentation is part of an INTERNAL release
// of the Computational Geometry Algorithms Library (CGAL). It is not
// intended for general use.
//
// ----------------------------------------------------------------------------
//
// release       : $CGAL_Revision: CGAL-1.0 $
// release_date  : $CGAL_Date: 1998/09/12 $
//
// file          : include/CGAL/bops_Triangle_2.h
// source        : include/CGAL/bops_Triangle_2.h
// revision      : $Revision: 1.1.2 $
// revision_date : $Date: Wed Dec  9 13:28:48 MET 1998  $
// author(s)     :             Wolfgang Freiseisen <Wolfgang.Freiseisen@risc.uni-linz.ac.at>
//
// coordinator   : RISC Linz
//  (Wolfgang Freiseisen <wfreisei@risc.uni-linz.ac.at>)
//
// 
// ============================================================================

#ifndef CGAL_BOPS_TRIANGLE2_H
#define CGAL_BOPS_TRIANGLE2_H


#include <CGAL/bops_traits_2.h>
#include <CGAL/Triangle_2.h>

/* NOT IMPLEMENTED YET
#include <CGAL/Triangle_2_Triangle_2_intersection.h>
bool 
CGAL_do_intersect( const CGAL_Triangle_2<R>& A,
                   const CGAL_Triangle_2<R>& B);
OutputIterator
CGAL_intersection( const CGAL_Triangle_2<R>& A,
                   const CGAL_Triangle_2<R>& B,
                   OutputIterator object_it);
{
  CGAL_bops_precondition_msg( !A.is_degenerate(),
                              "Triangle_2<R> A is degenerated");
  CGAL_bops_precondition_msg( !B.is_degenerate(),
                              "Triangle_2<R> B is degenerated");

  *object_it++= CGAL_intersection(A,B);
  return object_it;
}
*/


template < class R, class OutputIterator >
OutputIterator
CGAL_union(        const CGAL_Triangle_2<R>& A,
                   const CGAL_Triangle_2<R>& B,
                   OutputIterator object_it);
 
 
 
template < class R, class OutputIterator >
OutputIterator
CGAL_difference(   const CGAL_Triangle_2<R>& A,
                   const CGAL_Triangle_2<R>& B,
                   OutputIterator list_of_objects_it);
 
 
#ifdef CGAL_CFG_NO_AUTOMATIC_TEMPLATE_INCLUSION
#include <CGAL/bops_Triangle_2.C>
#endif

#endif // CGAL_BOPS_TRIANGLE2_H
