//  -*- Mode: c++ -*-
// ============================================================================
// 
// Copyright (c) 1997 The CGAL Consortium
//
// This software and related documentation is part of an INTERNAL release
// of the Computational Geometry Algorithms Library (CGAL). It is not
// intended for general use.
//
// ----------------------------------------------------------------------------
//
// release       : $CGAL_Revision: CGAL-1.0 $
// release_date  : $CGAL_Date: 1998/09/12 $
//
// file          : include/CGAL/bops_dcel_element.h
// source        : include/CGAL/bops_dcel_element.h
// revision      : $Revision: 1.1.2 $
// revision_date : $Date: Wed Dec  9 13:28:52 MET 1998  $
// author(s)     :             Wolfgang Freiseisen <Wolfgang.Freiseisen@risc.uni-linz.ac.at>
//
// coordinator   : RISC Linz
//  (Wolfgang Freiseisen <wfreisei@risc.uni-linz.ac.at>)
//
// 
// ============================================================================

#ifndef CGAL__DCEL_ELEMENT_H
#define CGAL__DCEL_ELEMENT_H

#include <CGAL/bops_dcel_defs.h>

/*
  ELEMENT in the DCEL:
  ---------------------
*/


class CGAL__Dcel_element_type {
public:
  CGAL__Dcel_element_type( int ind, CGAL__Dcel_Color col = CGAL__NO_COLOR )
        : _index(ind), _color(col) {}
  CGAL__Dcel_element_type( CGAL__Dcel_Color col = CGAL__NO_COLOR )
        : _index(-1), _color(col) {}

  CGAL__Dcel_Color    color() const  { return _color; }
  CGAL__Dcel_Color    set_color(const CGAL__Dcel_Color& c) {
    _color= c;
    return c;
  }
  bool    has_color(const CGAL__Dcel_Color& c) const {
    return color()& c ? true : false;
  }

  CGAL__Dcel_Color&   color()   { return _color; }
  int              index() const  { return _index; }

private:
  int _index;
  CGAL__Dcel_Color _color;
};

#endif /* CGAL__DCEL_ELEMENT_H */
