//  -*- Mode: c++ -*-
// ============================================================================
// 
// Copyright (c) 1997 The CGAL Consortium
//
// This software and related documentation is part of an INTERNAL release
// of the Computational Geometry Algorithms Library (CGAL). It is not
// intended for general use.
//
// ----------------------------------------------------------------------------
//
// release       : $CGAL_Revision: CGAL-1.0 $
// release_date  : $CGAL_Date: 1998/09/12 $
//
// file          : include/CGAL/bops_dcel_face.h
// source        : include/CGAL/bops_dcel_face.h
// revision      : $Revision: 1.1.2 $
// revision_date : $Date: Wed Dec  9 13:28:52 MET 1998  $
// author(s)     :             Wolfgang Freiseisen <Wolfgang.Freiseisen@risc.uni-linz.ac.at>
//
// coordinator   : RISC Linz
//  (Wolfgang Freiseisen <wfreisei@risc.uni-linz.ac.at>)
//
// 
// ============================================================================

#ifndef CGAL__DCEL_FACE_H
#define CGAL__DCEL_FACE_H

#include <CGAL/bops_dcel_element.h>

/*
  FACE in the DCEL:
  -----------------
  face_type:        header (HF), color
  face:             typedef const CGAL__Dcel_face_type*   CGAL__Dcel_face;
  container:        vector<CGAL__Dcel_face_type>
  face_iterator:    typedef vector<CGAL__Dcel_face_type>::const_iterator
  conversion:       face and face_iterator are type-identical
*/


template<class I>
class CGAL__Dcel_face_type : public CGAL__Dcel_element_type {
public:
#ifdef CGAL_CFG_INCOMPLETE_TYPE_BUG_4
  typedef CGAL__Dcel_edge_type<I>* edge;
#else
  typedef typename I::const_edges_iterator  edge;
#endif

  CGAL__Dcel_face_type(int ind, CGAL__Dcel_Color col = CGAL__NO_COLOR)
        : CGAL__Dcel_element_type(ind, col), _header(NULL) {}
  CGAL__Dcel_face_type( CGAL__Dcel_Color col = CGAL__NO_COLOR )
        : CGAL__Dcel_element_type(col), _header(NULL) {}

  edge  header() const { return _header; }

protected:
  edge&  header()  { return _header; }

private:
  edge _header;
  friend class CGAL__Dcel_base<I>;
};


#endif /* CGAL__DCEL_FACE_H */
