//  -*- Mode: c++ -*-
// ============================================================================
// 
// Copyright (c) 1997 The CGAL Consortium
//
// This software and related documentation is part of an INTERNAL release
// of the Computational Geometry Algorithms Library (CGAL). It is not
// intended for general use.
//
// ----------------------------------------------------------------------------
//
// release       : $CGAL_Revision: CGAL-1.0 $
// release_date  : $CGAL_Date: 1998/09/12 $
//
// file          : test/BooleanOperations/include/CGAL/test_bops.h
// source        : test/BooleanOperations/include/CGAL/test_bops.h
// revision      : $Revision: 1.1.2 $
// revision_date : $Date: Wed Dec  9 13:29:08 MET 1998  $
// author(s)     :                        Wolfgang Freiseisen <Wolfgang.Freiseisen@risc.uni-linz.ac.at>
//
// coordinator   : RISC Linz
//  (Wolfgang Freiseisen <wfreisei@risc.uni-linz.ac.at>)
//
// 
// ============================================================================

#ifndef TEST_BOPS_H
#define TEST_BOPS_H

#ifndef CGAL_BASIC_H
#include <CGAL/basic.h>
#endif
#ifndef CGAL_CARTESIAN_H
#include <CGAL/Cartesian.h>
#endif
#ifndef CGAL_HOMOGENEOUS_H
#include <CGAL/Homogeneous.h>
#endif

#include <list.h>
#ifndef CGAL_BOOLEAN_OPERATIONS_2_H
#include <CGAL/boolean_operations_2.h>
#endif

#ifndef Bops_test_arithmetic
#define Bops_test_arithmetic 2
#endif

#if Bops_test_arithmetic == 1
#ifndef CGAL_RATIONAL_H
#include <CGAL/Rational.h>
#endif
    typedef CGAL_Rational TestNum;            /* exact arithmetic */
#endif

#ifndef CGAL_QUOTIENT_H
#include <CGAL/Quotient.h>
#endif
#if Bops_test_arithmetic == 2
    typedef CGAL_Quotient<long int> TestNum;  /* exact but (very) finite */
#endif

#if Bops_test_arithmetic == 4
#ifndef CGAL_DOUBLE_H
#include <CGAL/Double.h>
#endif
    typedef double TestNum;             /* inexact arithmetic */
#endif

#ifdef CGAL_BOPS_HOMOGENEOUS
  typedef CGAL_Homogeneous<TestNum>  R_type;
#else
  typedef CGAL_Cartesian<TestNum>  R_type;
#endif

typedef CGAL_Point_2<R_type>           Point_2;
typedef CGAL_Segment_2<R_type>         Segment_2;
typedef CGAL_Triangle_2<R_type>        Triangle_2;
typedef CGAL_Iso_rectangle_2<R_type>   Iso_rectangle_2;
typedef list< Point_2 >                Container;
//typedef vector< Point_2 >              Container;
typedef CGAL_Polygon_2< CGAL_Polygon_traits_2<R_type>, Container >  Polygon_2;

#include "CGAL/test_bops_data.h"

#endif  // TEST_BOPS_H
